<html>
<head>
<title>OgrePixelConversions.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_421e028b72e6118d2afd1c1cfce2a3b8.html">src</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgrePixelConversions.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgrePixelConversions_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001  <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00029"></a>00029 <span class="comment">//using namespace Ogre;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// NB VC6 can&#39;t handle these templates</span>
<a name="l00032"></a>00032 <span class="preprocessor">#if OGRE_COMPILER != OGRE_COMPILER_MSVC || OGRE_COMP_VER &gt;= 1300</span>
<a name="l00033"></a>00033 <span class="preprocessor"></span>
<a name="l00034"></a>00034 <span class="preprocessor">#define FMTCONVERTERID(from,to) (((from)&lt;&lt;8)|(to))</span>
<a name="l00035"></a>00035 <span class="preprocessor"></span>
<a name="l00051"></a>00051 <span class="keyword">template</span> &lt;<span class="keyword">class</span> U&gt; <span class="keyword">struct </span>PixelBoxConverter 
<a name="l00052"></a>00052 {
<a name="l00053"></a>00053     <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> ID = U::ID;
<a name="l00054"></a>00054     <span class="keyword">static</span> <span class="keywordtype">void</span> conversion(<span class="keyword">const</span> <a class="code" href="classOgre_1_1PixelBox.html" title="A primitive describing a volume (3D), image (2D) or line (1D) of pixels in memory.">Ogre::PixelBox</a> &amp;src, <span class="keyword">const</span> <a class="code" href="classOgre_1_1PixelBox.html" title="A primitive describing a volume (3D), image (2D) or line (1D) of pixels in memory.">Ogre::PixelBox</a> &amp;dst)
<a name="l00055"></a>00055     {
<a name="l00056"></a>00056         <span class="keyword">typename</span> U::SrcType *srcptr = <span class="keyword">static_cast&lt;</span>typename U::SrcType*<span class="keyword">&gt;</span>(src.<a class="code" href="classOgre_1_1PixelBox.html#ac4fe215e13fc38d6a45e0c40ee2f1425" title="The data pointer.">data</a>)
<a name="l00057"></a>00057             + (src.<a class="code" href="structOgre_1_1Box.html#a8c667f45bbbe5be0577025436a7e50a0">left</a> + src.<a class="code" href="structOgre_1_1Box.html#aebfb3bd646373c45c9e38735640f6e3a">top</a> * src.<a class="code" href="classOgre_1_1PixelBox.html#aacf8f1ebed40c557389d9d1e9dda3b68" title="Number of elements between the leftmost pixel of one row and the left pixel of the next...">rowPitch</a> + src.<a class="code" href="structOgre_1_1Box.html#a6057f53bf949ee0725aeb52d1e480f4c">front</a> * src.<a class="code" href="classOgre_1_1PixelBox.html#a5f4ac4f2e735678fc8b3ddc1068674dd" title="Number of elements between the top left pixel of one (depth) slice and the top left pixel of the next...">slicePitch</a>);
<a name="l00058"></a>00058         <span class="keyword">typename</span> U::DstType *dstptr = <span class="keyword">static_cast&lt;</span>typename U::DstType*<span class="keyword">&gt;</span>(dst.<a class="code" href="classOgre_1_1PixelBox.html#ac4fe215e13fc38d6a45e0c40ee2f1425" title="The data pointer.">data</a>)
<a name="l00059"></a>00059             + (dst.<a class="code" href="structOgre_1_1Box.html#a8c667f45bbbe5be0577025436a7e50a0">left</a> + dst.<a class="code" href="structOgre_1_1Box.html#aebfb3bd646373c45c9e38735640f6e3a">top</a> * dst.<a class="code" href="classOgre_1_1PixelBox.html#aacf8f1ebed40c557389d9d1e9dda3b68" title="Number of elements between the leftmost pixel of one row and the left pixel of the next...">rowPitch</a> + dst.<a class="code" href="structOgre_1_1Box.html#a6057f53bf949ee0725aeb52d1e480f4c">front</a> * dst.<a class="code" href="classOgre_1_1PixelBox.html#a5f4ac4f2e735678fc8b3ddc1068674dd" title="Number of elements between the top left pixel of one (depth) slice and the top left pixel of the next...">slicePitch</a>);
<a name="l00060"></a>00060         <span class="keyword">const</span> <span class="keywordtype">size_t</span> srcSliceSkip = src.<a class="code" href="classOgre_1_1PixelBox.html#a27f6e0e9f80a2a3397ef5550875cee97" title="Get the number of elements between one past the right bottom pixel of one slice and the left top pixe...">getSliceSkip</a>();
<a name="l00061"></a>00061         <span class="keyword">const</span> <span class="keywordtype">size_t</span> dstSliceSkip = dst.<a class="code" href="classOgre_1_1PixelBox.html#a27f6e0e9f80a2a3397ef5550875cee97" title="Get the number of elements between one past the right bottom pixel of one slice and the left top pixe...">getSliceSkip</a>();
<a name="l00062"></a>00062         <span class="keyword">const</span> <span class="keywordtype">size_t</span> k = src.<a class="code" href="structOgre_1_1Box.html#a57531708bc749511715f37648d105aad">right</a> - src.<a class="code" href="structOgre_1_1Box.html#a8c667f45bbbe5be0577025436a7e50a0">left</a>;
<a name="l00063"></a>00063         <span class="keywordflow">for</span>(<span class="keywordtype">size_t</span> z=src.<a class="code" href="structOgre_1_1Box.html#a6057f53bf949ee0725aeb52d1e480f4c">front</a>; z&lt;src.<a class="code" href="structOgre_1_1Box.html#a26cb2e011c3dec1ff625716e1778233a">back</a>; z++) 
<a name="l00064"></a>00064         {
<a name="l00065"></a>00065             <span class="keywordflow">for</span>(<span class="keywordtype">size_t</span> y=src.<a class="code" href="structOgre_1_1Box.html#aebfb3bd646373c45c9e38735640f6e3a">top</a>; y&lt;src.<a class="code" href="structOgre_1_1Box.html#a66b5764c9ac1aad8410e9883c74b522a">bottom</a>; y++)
<a name="l00066"></a>00066             {
<a name="l00067"></a>00067                 <span class="keywordflow">for</span>(<span class="keywordtype">size_t</span> x=0; x&lt;k; x++)
<a name="l00068"></a>00068                 {
<a name="l00069"></a>00069                     dstptr[x] = U::pixelConvert(srcptr[x]);
<a name="l00070"></a>00070                 }
<a name="l00071"></a>00071                 srcptr += src.<a class="code" href="classOgre_1_1PixelBox.html#aacf8f1ebed40c557389d9d1e9dda3b68" title="Number of elements between the leftmost pixel of one row and the left pixel of the next...">rowPitch</a>;
<a name="l00072"></a>00072                 dstptr += dst.<a class="code" href="classOgre_1_1PixelBox.html#aacf8f1ebed40c557389d9d1e9dda3b68" title="Number of elements between the leftmost pixel of one row and the left pixel of the next...">rowPitch</a>;
<a name="l00073"></a>00073             }
<a name="l00074"></a>00074             srcptr += srcSliceSkip;
<a name="l00075"></a>00075             dstptr += dstSliceSkip;
<a name="l00076"></a>00076         }    
<a name="l00077"></a>00077     }
<a name="l00078"></a>00078 };
<a name="l00079"></a>00079 
<a name="l00080"></a>00080 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> U, <span class="keywordtype">int</span> <span class="keywordtype">id</span>&gt; <span class="keyword">struct </span>PixelConverter {
<a name="l00081"></a>00081     <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> ID = id;
<a name="l00082"></a>00082     <span class="keyword">typedef</span> T SrcType;
<a name="l00083"></a>00083     <span class="keyword">typedef</span> U DstType;    
<a name="l00084"></a>00084     
<a name="l00085"></a>00085     <span class="comment">//inline static DstType pixelConvert(const SrcType &amp;inp);</span>
<a name="l00086"></a>00086 };
<a name="l00087"></a>00087 
<a name="l00088"></a>00088 
<a name="l00090"></a>00090 <span class="keyword">struct </span>Col3b {
<a name="l00091"></a>00091     Col3b(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> a, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> b, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c): 
<a name="l00092"></a>00092         x((Ogre::<a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a>)a), y((Ogre::<a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a>)b), z((Ogre::<a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a>)c) { }
<a name="l00093"></a>00093     <a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">Ogre::uint8</a> x,y,z;
<a name="l00094"></a>00094 };
<a name="l00096"></a>00096 <span class="keyword">struct </span>Col3f {
<a name="l00097"></a>00097     Col3f(<span class="keywordtype">float</span> inR, <span class="keywordtype">float</span> inG, <span class="keywordtype">float</span> inB):
<a name="l00098"></a>00098         r(inR), g(inG), b(inB) { }
<a name="l00099"></a>00099     <span class="keywordtype">float</span> r,g,b;
<a name="l00100"></a>00100 };
<a name="l00102"></a>00102 <span class="keyword">struct </span>Col4f {
<a name="l00103"></a>00103     Col4f(<span class="keywordtype">float</span> inR, <span class="keywordtype">float</span> inG, <span class="keywordtype">float</span> inB, <span class="keywordtype">float</span> inA):
<a name="l00104"></a>00104         r(inR), g(inG), b(inB), a(inA) { }
<a name="l00105"></a>00105     <span class="keywordtype">float</span> r,g,b,a;
<a name="l00106"></a>00106 };
<a name="l00107"></a>00107 
<a name="l00108"></a>00108 <span class="keyword">struct </span>A8R8G8B8toA8B8G8R8: <span class="keyword">public</span> PixelConverter &lt;Ogre::uint32, Ogre::uint32, FMTCONVERTERID(Ogre::PF_A8R8G8B8, Ogre::PF_A8B8G8R8)&gt;
<a name="l00109"></a>00109 {
<a name="l00110"></a>00110     <span class="keyword">inline</span> <span class="keyword">static</span> DstType pixelConvert(SrcType inp)
<a name="l00111"></a>00111     {
<a name="l00112"></a>00112         <span class="keywordflow">return</span> ((inp&amp;0x000000FF)&lt;&lt;16)|(inp&amp;0xFF00FF00)|((inp&amp;0x00FF0000)&gt;&gt;16);
<a name="l00113"></a>00113     }
<a name="l00114"></a>00114 };
<a name="l00115"></a>00115 
<a name="l00116"></a>00116 <span class="keyword">struct </span>A8R8G8B8toB8G8R8A8: <span class="keyword">public</span> PixelConverter &lt;Ogre::uint32, Ogre::uint32, FMTCONVERTERID(Ogre::PF_A8R8G8B8, Ogre::PF_B8G8R8A8)&gt;
<a name="l00117"></a>00117 {
<a name="l00118"></a>00118     <span class="keyword">inline</span> <span class="keyword">static</span> DstType pixelConvert(SrcType inp)
<a name="l00119"></a>00119     {
<a name="l00120"></a>00120         <span class="keywordflow">return</span> ((inp&amp;0x000000FF)&lt;&lt;24)|((inp&amp;0x0000FF00)&lt;&lt;8)|((inp&amp;0x00FF0000)&gt;&gt;8)|((inp&amp;0xFF000000)&gt;&gt;24);
<a name="l00121"></a>00121     }
<a name="l00122"></a>00122 };
<a name="l00123"></a>00123 
<a name="l00124"></a>00124 <span class="keyword">struct </span>A8R8G8B8toR8G8B8A8: <span class="keyword">public</span> PixelConverter &lt;Ogre::uint32, Ogre::uint32, FMTCONVERTERID(Ogre::PF_A8R8G8B8, Ogre::PF_R8G8B8A8)&gt;
<a name="l00125"></a>00125 {
<a name="l00126"></a>00126     <span class="keyword">inline</span> <span class="keyword">static</span> DstType pixelConvert(SrcType inp)
<a name="l00127"></a>00127     {
<a name="l00128"></a>00128         <span class="keywordflow">return</span> ((inp&amp;0x00FFFFFF)&lt;&lt;8)|((inp&amp;0xFF000000)&gt;&gt;24);
<a name="l00129"></a>00129     }
<a name="l00130"></a>00130 };
<a name="l00131"></a>00131 
<a name="l00132"></a>00132 <span class="keyword">struct </span>A8B8G8R8toA8R8G8B8: <span class="keyword">public</span> PixelConverter &lt;Ogre::uint32, Ogre::uint32, FMTCONVERTERID(Ogre::PF_A8B8G8R8, Ogre::PF_A8R8G8B8)&gt;
<a name="l00133"></a>00133 {
<a name="l00134"></a>00134     <span class="keyword">inline</span> <span class="keyword">static</span> DstType pixelConvert(SrcType inp)
<a name="l00135"></a>00135     {
<a name="l00136"></a>00136         <span class="keywordflow">return</span> ((inp&amp;0x000000FF)&lt;&lt;16)|(inp&amp;0xFF00FF00)|((inp&amp;0x00FF0000)&gt;&gt;16);
<a name="l00137"></a>00137     }
<a name="l00138"></a>00138 };
<a name="l00139"></a>00139 
<a name="l00140"></a>00140 <span class="keyword">struct </span>A8B8G8R8toB8G8R8A8: <span class="keyword">public</span> PixelConverter &lt;Ogre::uint32, Ogre::uint32, FMTCONVERTERID(Ogre::PF_A8B8G8R8, Ogre::PF_B8G8R8A8)&gt;
<a name="l00141"></a>00141 {
<a name="l00142"></a>00142     <span class="keyword">inline</span> <span class="keyword">static</span> DstType pixelConvert(SrcType inp)
<a name="l00143"></a>00143     {
<a name="l00144"></a>00144         <span class="keywordflow">return</span> ((inp&amp;0x00FFFFFF)&lt;&lt;8)|((inp&amp;0xFF000000)&gt;&gt;24);
<a name="l00145"></a>00145     }
<a name="l00146"></a>00146 };
<a name="l00147"></a>00147 
<a name="l00148"></a>00148 <span class="keyword">struct </span>A8B8G8R8toR8G8B8A8: <span class="keyword">public</span> PixelConverter &lt;Ogre::uint32, Ogre::uint32, FMTCONVERTERID(Ogre::PF_A8B8G8R8, Ogre::PF_R8G8B8A8)&gt;
<a name="l00149"></a>00149 {
<a name="l00150"></a>00150     <span class="keyword">inline</span> <span class="keyword">static</span> DstType pixelConvert(SrcType inp)
<a name="l00151"></a>00151     {
<a name="l00152"></a>00152         <span class="keywordflow">return</span> ((inp&amp;0x000000FF)&lt;&lt;24)|((inp&amp;0x0000FF00)&lt;&lt;8)|((inp&amp;0x00FF0000)&gt;&gt;8)|((inp&amp;0xFF000000)&gt;&gt;24);
<a name="l00153"></a>00153     }
<a name="l00154"></a>00154 };
<a name="l00155"></a>00155 
<a name="l00156"></a>00156 <span class="keyword">struct </span>B8G8R8A8toA8R8G8B8: <span class="keyword">public</span> PixelConverter &lt;Ogre::uint32, Ogre::uint32, FMTCONVERTERID(Ogre::PF_B8G8R8A8, Ogre::PF_A8R8G8B8)&gt;
<a name="l00157"></a>00157 {
<a name="l00158"></a>00158     <span class="keyword">inline</span> <span class="keyword">static</span> DstType pixelConvert(SrcType inp)
<a name="l00159"></a>00159     {
<a name="l00160"></a>00160         <span class="keywordflow">return</span> ((inp&amp;0x000000FF)&lt;&lt;24)|((inp&amp;0x0000FF00)&lt;&lt;8)|((inp&amp;0x00FF0000)&gt;&gt;8)|((inp&amp;0xFF000000)&gt;&gt;24);
<a name="l00161"></a>00161     }
<a name="l00162"></a>00162 };
<a name="l00163"></a>00163 
<a name="l00164"></a>00164 <span class="keyword">struct </span>B8G8R8A8toA8B8G8R8: <span class="keyword">public</span> PixelConverter &lt;Ogre::uint32, Ogre::uint32, FMTCONVERTERID(Ogre::PF_B8G8R8A8, Ogre::PF_A8B8G8R8)&gt;
<a name="l00165"></a>00165 {
<a name="l00166"></a>00166     <span class="keyword">inline</span> <span class="keyword">static</span> DstType pixelConvert(SrcType inp)
<a name="l00167"></a>00167     {
<a name="l00168"></a>00168         <span class="keywordflow">return</span> ((inp&amp;0x000000FF)&lt;&lt;24)|((inp&amp;0xFFFFFF00)&gt;&gt;8);
<a name="l00169"></a>00169     }
<a name="l00170"></a>00170 };
<a name="l00171"></a>00171 
<a name="l00172"></a>00172 <span class="keyword">struct </span>B8G8R8A8toR8G8B8A8: <span class="keyword">public</span> PixelConverter &lt;Ogre::uint32, Ogre::uint32, FMTCONVERTERID(Ogre::PF_B8G8R8A8, Ogre::PF_R8G8B8A8)&gt;
<a name="l00173"></a>00173 {
<a name="l00174"></a>00174     <span class="keyword">inline</span> <span class="keyword">static</span> DstType pixelConvert(SrcType inp)
<a name="l00175"></a>00175     {
<a name="l00176"></a>00176         <span class="keywordflow">return</span> ((inp&amp;0x0000FF00)&lt;&lt;16)|(inp&amp;0x00FF00FF)|((inp&amp;0xFF000000)&gt;&gt;16);
<a name="l00177"></a>00177     }
<a name="l00178"></a>00178 };
<a name="l00179"></a>00179 
<a name="l00180"></a>00180 <span class="keyword">struct </span>R8G8B8A8toA8R8G8B8: <span class="keyword">public</span> PixelConverter &lt;Ogre::uint32, Ogre::uint32, FMTCONVERTERID(Ogre::PF_R8G8B8A8, Ogre::PF_A8R8G8B8)&gt;
<a name="l00181"></a>00181 {
<a name="l00182"></a>00182     <span class="keyword">inline</span> <span class="keyword">static</span> DstType pixelConvert(SrcType inp)
<a name="l00183"></a>00183     {
<a name="l00184"></a>00184         <span class="keywordflow">return</span> ((inp&amp;0x000000FF)&lt;&lt;24)|((inp&amp;0xFFFFFF00)&gt;&gt;8);
<a name="l00185"></a>00185     }
<a name="l00186"></a>00186 };
<a name="l00187"></a>00187 
<a name="l00188"></a>00188 <span class="keyword">struct </span>R8G8B8A8toA8B8G8R8: <span class="keyword">public</span> PixelConverter &lt;Ogre::uint32, Ogre::uint32, FMTCONVERTERID(Ogre::PF_R8G8B8A8, Ogre::PF_A8B8G8R8)&gt;
<a name="l00189"></a>00189 {
<a name="l00190"></a>00190     <span class="keyword">inline</span> <span class="keyword">static</span> DstType pixelConvert(SrcType inp)
<a name="l00191"></a>00191     {
<a name="l00192"></a>00192         <span class="keywordflow">return</span> ((inp&amp;0x000000FF)&lt;&lt;24)|((inp&amp;0x0000FF00)&lt;&lt;8)|((inp&amp;0x00FF0000)&gt;&gt;8)|((inp&amp;0xFF000000)&gt;&gt;24);
<a name="l00193"></a>00193     }
<a name="l00194"></a>00194 };
<a name="l00195"></a>00195 
<a name="l00196"></a>00196 <span class="keyword">struct </span>R8G8B8A8toB8G8R8A8: <span class="keyword">public</span> PixelConverter &lt;Ogre::uint32, Ogre::uint32, FMTCONVERTERID(Ogre::PF_R8G8B8A8, Ogre::PF_B8G8R8A8)&gt;
<a name="l00197"></a>00197 {
<a name="l00198"></a>00198     <span class="keyword">inline</span> <span class="keyword">static</span> DstType pixelConvert(SrcType inp)
<a name="l00199"></a>00199     {
<a name="l00200"></a>00200         <span class="keywordflow">return</span> ((inp&amp;0x0000FF00)&lt;&lt;16)|(inp&amp;0x00FF00FF)|((inp&amp;0xFF000000)&gt;&gt;16);
<a name="l00201"></a>00201     }
<a name="l00202"></a>00202 };
<a name="l00203"></a>00203 
<a name="l00204"></a>00204 <span class="keyword">struct </span>A8B8G8R8toL8: <span class="keyword">public</span> PixelConverter &lt;Ogre::uint32, Ogre::uint8, FMTCONVERTERID(Ogre::PF_A8B8G8R8, Ogre::PF_L8)&gt;
<a name="l00205"></a>00205 {
<a name="l00206"></a>00206     <span class="keyword">inline</span> <span class="keyword">static</span> DstType pixelConvert(SrcType inp)
<a name="l00207"></a>00207     {
<a name="l00208"></a>00208         <span class="keywordflow">return</span> (<a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">Ogre::uint8</a>)(inp&amp;0x000000FF);
<a name="l00209"></a>00209     }
<a name="l00210"></a>00210 };
<a name="l00211"></a>00211 
<a name="l00212"></a>00212 <span class="keyword">struct </span>L8toA8B8G8R8: <span class="keyword">public</span> PixelConverter &lt;Ogre::uint8, Ogre::uint32, FMTCONVERTERID(Ogre::PF_L8, Ogre::PF_A8B8G8R8)&gt;
<a name="l00213"></a>00213 {
<a name="l00214"></a>00214     <span class="keyword">inline</span> <span class="keyword">static</span> DstType pixelConvert(SrcType inp)
<a name="l00215"></a>00215     {
<a name="l00216"></a>00216         <span class="keywordflow">return</span> 0xFF000000|(((<span class="keywordtype">unsigned</span> int)inp)&lt;&lt;0)|(((<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)inp)&lt;&lt;8)|(((<span class="keywordtype">unsigned</span> int)inp)&lt;&lt;16);
<a name="l00217"></a>00217     }
<a name="l00218"></a>00218 };
<a name="l00219"></a>00219 
<a name="l00220"></a>00220 <span class="keyword">struct </span>A8R8G8B8toL8: <span class="keyword">public</span> PixelConverter &lt;Ogre::uint32, Ogre::uint8, FMTCONVERTERID(Ogre::PF_A8R8G8B8, Ogre::PF_L8)&gt;
<a name="l00221"></a>00221 {
<a name="l00222"></a>00222     <span class="keyword">inline</span> <span class="keyword">static</span> DstType pixelConvert(SrcType inp)
<a name="l00223"></a>00223     {
<a name="l00224"></a>00224         <span class="keywordflow">return</span> (<a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">Ogre::uint8</a>)((inp&amp;0x00FF0000)&gt;&gt;16);
<a name="l00225"></a>00225     }
<a name="l00226"></a>00226 };
<a name="l00227"></a>00227 
<a name="l00228"></a>00228 <span class="keyword">struct </span>L8toA8R8G8B8: <span class="keyword">public</span> PixelConverter &lt;Ogre::uint8, Ogre::uint32, FMTCONVERTERID(Ogre::PF_L8, Ogre::PF_A8R8G8B8)&gt;
<a name="l00229"></a>00229 {
<a name="l00230"></a>00230     <span class="keyword">inline</span> <span class="keyword">static</span> DstType pixelConvert(SrcType inp)
<a name="l00231"></a>00231     {
<a name="l00232"></a>00232         <span class="keywordflow">return</span> 0xFF000000|(((<span class="keywordtype">unsigned</span> int)inp)&lt;&lt;0)|(((<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)inp)&lt;&lt;8)|(((<span class="keywordtype">unsigned</span> int)inp)&lt;&lt;16);
<a name="l00233"></a>00233     }
<a name="l00234"></a>00234 };
<a name="l00235"></a>00235 
<a name="l00236"></a>00236 <span class="keyword">struct </span>B8G8R8A8toL8: <span class="keyword">public</span> PixelConverter &lt;Ogre::uint32, Ogre::uint8, FMTCONVERTERID(Ogre::PF_B8G8R8A8, Ogre::PF_L8)&gt;
<a name="l00237"></a>00237 {
<a name="l00238"></a>00238     <span class="keyword">inline</span> <span class="keyword">static</span> DstType pixelConvert(SrcType inp)
<a name="l00239"></a>00239     {
<a name="l00240"></a>00240         <span class="keywordflow">return</span> (<a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">Ogre::uint8</a>)((inp&amp;0x0000FF00)&gt;&gt;8);
<a name="l00241"></a>00241     }
<a name="l00242"></a>00242 };
<a name="l00243"></a>00243 
<a name="l00244"></a>00244 <span class="keyword">struct </span>L8toB8G8R8A8: <span class="keyword">public</span> PixelConverter &lt;Ogre::uint8, Ogre::uint32, FMTCONVERTERID(Ogre::PF_L8, Ogre::PF_B8G8R8A8)&gt;
<a name="l00245"></a>00245 {
<a name="l00246"></a>00246     <span class="keyword">inline</span> <span class="keyword">static</span> DstType pixelConvert(SrcType inp)
<a name="l00247"></a>00247     {
<a name="l00248"></a>00248         <span class="keywordflow">return</span> 0x000000FF|(((<span class="keywordtype">unsigned</span> int)inp)&lt;&lt;8)|(((<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)inp)&lt;&lt;16)|(((<span class="keywordtype">unsigned</span> int)inp)&lt;&lt;24);
<a name="l00249"></a>00249     }
<a name="l00250"></a>00250 };
<a name="l00251"></a>00251 
<a name="l00252"></a>00252 <span class="keyword">struct </span>L8toL16: <span class="keyword">public</span> PixelConverter &lt;Ogre::uint8, Ogre::uint16, FMTCONVERTERID(Ogre::PF_L8, Ogre::PF_L16)&gt;
<a name="l00253"></a>00253 {
<a name="l00254"></a>00254     <span class="keyword">inline</span> <span class="keyword">static</span> DstType pixelConvert(SrcType inp)
<a name="l00255"></a>00255     {
<a name="l00256"></a>00256         <span class="keywordflow">return</span> (<a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">Ogre::uint16</a>)((((<span class="keywordtype">unsigned</span> int)inp)&lt;&lt;8)|(((<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)inp)));
<a name="l00257"></a>00257     }
<a name="l00258"></a>00258 };
<a name="l00259"></a>00259 
<a name="l00260"></a>00260 <span class="keyword">struct </span>L16toL8: <span class="keyword">public</span> PixelConverter &lt;Ogre::uint16, Ogre::uint8, FMTCONVERTERID(Ogre::PF_L16, Ogre::PF_L8)&gt;
<a name="l00261"></a>00261 {
<a name="l00262"></a>00262     <span class="keyword">inline</span> <span class="keyword">static</span> DstType pixelConvert(SrcType inp)
<a name="l00263"></a>00263     {
<a name="l00264"></a>00264         <span class="keywordflow">return</span> (<a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">Ogre::uint8</a>)(inp&gt;&gt;8);
<a name="l00265"></a>00265     }
<a name="l00266"></a>00266 };
<a name="l00267"></a>00267 
<a name="l00268"></a>00268 <span class="keyword">struct </span>R8G8B8toB8G8R8: <span class="keyword">public</span> PixelConverter &lt;Col3b, Col3b, FMTCONVERTERID(Ogre::PF_R8G8B8, Ogre::PF_B8G8R8)&gt;
<a name="l00269"></a>00269 {
<a name="l00270"></a>00270     <span class="keyword">inline</span> <span class="keyword">static</span> DstType pixelConvert(<span class="keyword">const</span> SrcType &amp;inp)
<a name="l00271"></a>00271     {
<a name="l00272"></a>00272         <span class="keywordflow">return</span> Col3b(inp.z, inp.y, inp.x);
<a name="l00273"></a>00273     }  
<a name="l00274"></a>00274 };
<a name="l00275"></a>00275 
<a name="l00276"></a>00276 <span class="keyword">struct </span>B8G8R8toR8G8B8: <span class="keyword">public</span> PixelConverter &lt;Col3b, Col3b, FMTCONVERTERID(Ogre::PF_B8G8R8, Ogre::PF_R8G8B8)&gt;
<a name="l00277"></a>00277 {
<a name="l00278"></a>00278     <span class="keyword">inline</span> <span class="keyword">static</span> DstType pixelConvert(<span class="keyword">const</span> SrcType &amp;inp)
<a name="l00279"></a>00279     {
<a name="l00280"></a>00280         <span class="keywordflow">return</span> Col3b(inp.z, inp.y, inp.x);
<a name="l00281"></a>00281     }  
<a name="l00282"></a>00282 };
<a name="l00283"></a>00283 
<a name="l00284"></a>00284 <span class="comment">// X8Y8Z8 -&gt;  X8&lt;&lt;xshift Y8&lt;&lt;yshift Z8&lt;&lt;zshift A8&lt;&lt;ashift</span>
<a name="l00285"></a>00285 <span class="keyword">template</span> &lt;<span class="keywordtype">int</span> <span class="keywordtype">id</span>, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> xshift, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> yshift, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> zshift, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ashift&gt; <span class="keyword">struct </span>Col3btoUint32swizzler:
<a name="l00286"></a>00286     <span class="keyword">public</span> PixelConverter &lt;Col3b, Ogre::uint32, id&gt;
<a name="l00287"></a>00287 {
<a name="l00288"></a>00288     <span class="keyword">inline</span> <span class="keyword">static</span> <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">Ogre::uint32</a> pixelConvert(<span class="keyword">const</span> Col3b &amp;inp)
<a name="l00289"></a>00289     {
<a name="l00290"></a>00290 <span class="preprocessor">#if OGRE_ENDIAN == OGRE_ENDIAN_BIG</span>
<a name="l00291"></a>00291 <span class="preprocessor"></span>        <span class="keywordflow">return</span> (0xFF&lt;&lt;ashift) | (((<span class="keywordtype">unsigned</span> int)inp.x)&lt;&lt;xshift) | (((<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)inp.y)&lt;&lt;yshift) | (((<span class="keywordtype">unsigned</span> int)inp.z)&lt;&lt;zshift);
<a name="l00292"></a>00292 <span class="preprocessor">#else</span>
<a name="l00293"></a>00293 <span class="preprocessor"></span>        <span class="keywordflow">return</span> (0xFF&lt;&lt;ashift) | (((<span class="keywordtype">unsigned</span> int)inp.x)&lt;&lt;zshift) | (((<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)inp.y)&lt;&lt;yshift) | (((<span class="keywordtype">unsigned</span> int)inp.z)&lt;&lt;xshift);
<a name="l00294"></a>00294 <span class="preprocessor">#endif</span>
<a name="l00295"></a>00295 <span class="preprocessor"></span>    }
<a name="l00296"></a>00296 };
<a name="l00297"></a>00297 
<a name="l00298"></a>00298 <span class="keyword">struct </span>R8G8B8toA8R8G8B8: <span class="keyword">public</span> Col3btoUint32swizzler&lt;FMTCONVERTERID(Ogre::PF_R8G8B8, Ogre::PF_A8R8G8B8), 16, 8, 0, 24&gt; { };
<a name="l00299"></a>00299 <span class="keyword">struct </span>B8G8R8toA8R8G8B8: <span class="keyword">public</span> Col3btoUint32swizzler&lt;FMTCONVERTERID(Ogre::PF_B8G8R8, Ogre::PF_A8R8G8B8), 0, 8, 16, 24&gt; { };
<a name="l00300"></a>00300 <span class="keyword">struct </span>R8G8B8toA8B8G8R8: <span class="keyword">public</span> Col3btoUint32swizzler&lt;FMTCONVERTERID(Ogre::PF_R8G8B8, Ogre::PF_A8B8G8R8), 0, 8, 16, 24&gt; { };
<a name="l00301"></a>00301 <span class="keyword">struct </span>B8G8R8toA8B8G8R8: <span class="keyword">public</span> Col3btoUint32swizzler&lt;FMTCONVERTERID(Ogre::PF_B8G8R8, Ogre::PF_A8B8G8R8), 16, 8, 0, 24&gt; { };
<a name="l00302"></a>00302 <span class="keyword">struct </span>R8G8B8toB8G8R8A8: <span class="keyword">public</span> Col3btoUint32swizzler&lt;FMTCONVERTERID(Ogre::PF_R8G8B8, Ogre::PF_B8G8R8A8), 8, 16, 24, 0&gt; { };
<a name="l00303"></a>00303 <span class="keyword">struct </span>B8G8R8toB8G8R8A8: <span class="keyword">public</span> Col3btoUint32swizzler&lt;FMTCONVERTERID(Ogre::PF_B8G8R8, Ogre::PF_B8G8R8A8), 24, 16, 8, 0&gt; { };
<a name="l00304"></a>00304 
<a name="l00305"></a>00305 <span class="keyword">struct </span>A8R8G8B8toR8G8B8: <span class="keyword">public</span> PixelConverter &lt;Ogre::uint32, Col3b, FMTCONVERTERID(Ogre::PF_A8R8G8B8, Ogre::PF_BYTE_RGB)&gt;
<a name="l00306"></a>00306 {
<a name="l00307"></a>00307     <span class="keyword">inline</span> <span class="keyword">static</span> DstType pixelConvert(<a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">Ogre::uint32</a> inp)
<a name="l00308"></a>00308     {
<a name="l00309"></a>00309         <span class="keywordflow">return</span> Col3b((<a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">Ogre::uint8</a>)((inp&gt;&gt;16)&amp;0xFF), (<a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">Ogre::uint8</a>)((inp&gt;&gt;8)&amp;0xFF), (<a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">Ogre::uint8</a>)((inp&gt;&gt;0)&amp;0xFF));
<a name="l00310"></a>00310     }
<a name="l00311"></a>00311 };
<a name="l00312"></a>00312 <span class="keyword">struct </span>A8R8G8B8toB8G8R8: <span class="keyword">public</span> PixelConverter &lt;Ogre::uint32, Col3b, FMTCONVERTERID(Ogre::PF_A8R8G8B8, Ogre::PF_BYTE_BGR)&gt;
<a name="l00313"></a>00313 {
<a name="l00314"></a>00314     <span class="keyword">inline</span> <span class="keyword">static</span> DstType pixelConvert(<a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">Ogre::uint32</a> inp)
<a name="l00315"></a>00315     {
<a name="l00316"></a>00316         <span class="keywordflow">return</span> Col3b((<a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">Ogre::uint8</a>)((inp&gt;&gt;0)&amp;0xFF), (<a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">Ogre::uint8</a>)((inp&gt;&gt;8)&amp;0xFF), (<a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">Ogre::uint8</a>)((inp&gt;&gt;16)&amp;0xFF));
<a name="l00317"></a>00317     }
<a name="l00318"></a>00318 };
<a name="l00319"></a>00319 
<a name="l00320"></a>00320 <span class="comment">// Only conversions from X8R8G8B8 to formats with alpha need to be defined, the rest is implicitly the same</span>
<a name="l00321"></a>00321 <span class="comment">// as A8R8G8B8</span>
<a name="l00322"></a>00322 <span class="keyword">struct </span>X8R8G8B8toA8R8G8B8: <span class="keyword">public</span> PixelConverter &lt;Ogre::uint32, Ogre::uint32, FMTCONVERTERID(Ogre::PF_X8R8G8B8, Ogre::PF_A8R8G8B8)&gt;
<a name="l00323"></a>00323 {
<a name="l00324"></a>00324     <span class="keyword">inline</span> <span class="keyword">static</span> DstType pixelConvert(SrcType inp)
<a name="l00325"></a>00325     {
<a name="l00326"></a>00326         <span class="keywordflow">return</span> inp | 0xFF000000;
<a name="l00327"></a>00327     }
<a name="l00328"></a>00328 };
<a name="l00329"></a>00329 <span class="keyword">struct </span>X8R8G8B8toA8B8G8R8: <span class="keyword">public</span> PixelConverter &lt;Ogre::uint32, Ogre::uint32, FMTCONVERTERID(Ogre::PF_X8R8G8B8, Ogre::PF_A8B8G8R8)&gt;
<a name="l00330"></a>00330 {
<a name="l00331"></a>00331     <span class="keyword">inline</span> <span class="keyword">static</span> DstType pixelConvert(SrcType inp)
<a name="l00332"></a>00332     {
<a name="l00333"></a>00333         <span class="keywordflow">return</span> ((inp&amp;0x0000FF)&lt;&lt;16)|((inp&amp;0xFF0000)&gt;&gt;16)|(inp&amp;0x00FF00)|0xFF000000;
<a name="l00334"></a>00334     }
<a name="l00335"></a>00335 };
<a name="l00336"></a>00336 <span class="keyword">struct </span>X8R8G8B8toB8G8R8A8: <span class="keyword">public</span> PixelConverter &lt;Ogre::uint32, Ogre::uint32, FMTCONVERTERID(Ogre::PF_X8R8G8B8, Ogre::PF_B8G8R8A8)&gt;
<a name="l00337"></a>00337 {
<a name="l00338"></a>00338     <span class="keyword">inline</span> <span class="keyword">static</span> DstType pixelConvert(SrcType inp)
<a name="l00339"></a>00339     {
<a name="l00340"></a>00340         <span class="keywordflow">return</span> ((inp&amp;0x0000FF)&lt;&lt;24)|((inp&amp;0xFF0000)&gt;&gt;8)|((inp&amp;0x00FF00)&lt;&lt;8)|0x000000FF;
<a name="l00341"></a>00341     }
<a name="l00342"></a>00342 };
<a name="l00343"></a>00343 <span class="keyword">struct </span>X8R8G8B8toR8G8B8A8: <span class="keyword">public</span> PixelConverter &lt;Ogre::uint32, Ogre::uint32, FMTCONVERTERID(Ogre::PF_X8R8G8B8, Ogre::PF_R8G8B8A8)&gt;
<a name="l00344"></a>00344 {
<a name="l00345"></a>00345     <span class="keyword">inline</span> <span class="keyword">static</span> DstType pixelConvert(SrcType inp)
<a name="l00346"></a>00346     {
<a name="l00347"></a>00347         <span class="keywordflow">return</span> ((inp&amp;0xFFFFFF)&lt;&lt;8)|0x000000FF;
<a name="l00348"></a>00348     }
<a name="l00349"></a>00349 };
<a name="l00350"></a>00350 
<a name="l00351"></a>00351 <span class="comment">// X8B8G8R8</span>
<a name="l00352"></a>00352 <span class="keyword">struct </span>X8B8G8R8toA8R8G8B8: <span class="keyword">public</span> PixelConverter &lt;Ogre::uint32, Ogre::uint32, FMTCONVERTERID(Ogre::PF_X8B8G8R8, Ogre::PF_A8R8G8B8)&gt;
<a name="l00353"></a>00353 {
<a name="l00354"></a>00354     <span class="keyword">inline</span> <span class="keyword">static</span> DstType pixelConvert(SrcType inp)
<a name="l00355"></a>00355     {
<a name="l00356"></a>00356         <span class="keywordflow">return</span> ((inp&amp;0x0000FF)&lt;&lt;16)|((inp&amp;0xFF0000)&gt;&gt;16)|(inp&amp;0x00FF00)|0xFF000000;
<a name="l00357"></a>00357     }
<a name="l00358"></a>00358 };
<a name="l00359"></a>00359 <span class="keyword">struct </span>X8B8G8R8toA8B8G8R8: <span class="keyword">public</span> PixelConverter &lt;Ogre::uint32, Ogre::uint32, FMTCONVERTERID(Ogre::PF_X8B8G8R8, Ogre::PF_A8B8G8R8)&gt;
<a name="l00360"></a>00360 {
<a name="l00361"></a>00361     <span class="keyword">inline</span> <span class="keyword">static</span> DstType pixelConvert(SrcType inp)
<a name="l00362"></a>00362     {
<a name="l00363"></a>00363         <span class="keywordflow">return</span> inp | 0xFF000000;
<a name="l00364"></a>00364     }
<a name="l00365"></a>00365 };
<a name="l00366"></a>00366 <span class="keyword">struct </span>X8B8G8R8toB8G8R8A8: <span class="keyword">public</span> PixelConverter &lt;Ogre::uint32, Ogre::uint32, FMTCONVERTERID(Ogre::PF_X8B8G8R8, Ogre::PF_B8G8R8A8)&gt;
<a name="l00367"></a>00367 {
<a name="l00368"></a>00368     <span class="keyword">inline</span> <span class="keyword">static</span> DstType pixelConvert(SrcType inp)
<a name="l00369"></a>00369     {
<a name="l00370"></a>00370         <span class="keywordflow">return</span> ((inp&amp;0xFFFFFF)&lt;&lt;8)|0x000000FF;
<a name="l00371"></a>00371     }
<a name="l00372"></a>00372 };
<a name="l00373"></a>00373 <span class="keyword">struct </span>X8B8G8R8toR8G8B8A8: <span class="keyword">public</span> PixelConverter &lt;Ogre::uint32, Ogre::uint32, FMTCONVERTERID(Ogre::PF_X8B8G8R8, Ogre::PF_R8G8B8A8)&gt;
<a name="l00374"></a>00374 {
<a name="l00375"></a>00375     <span class="keyword">inline</span> <span class="keyword">static</span> DstType pixelConvert(SrcType inp)
<a name="l00376"></a>00376     {
<a name="l00377"></a>00377         <span class="keywordflow">return</span> ((inp&amp;0x0000FF)&lt;&lt;24)|((inp&amp;0xFF0000)&gt;&gt;8)|((inp&amp;0x00FF00)&lt;&lt;8)|0x000000FF;
<a name="l00378"></a>00378     }
<a name="l00379"></a>00379 };
<a name="l00380"></a>00380 
<a name="l00381"></a>00381 
<a name="l00382"></a>00382 <span class="preprocessor">#define CASECONVERTER(type) case type::ID : PixelBoxConverter&lt;type&gt;::conversion(src, dst); return 1;</span>
<a name="l00383"></a>00383 <span class="preprocessor"></span>
<a name="l00384"></a>00384 <span class="keyword">inline</span> <span class="keywordtype">int</span> doOptimizedConversion(<span class="keyword">const</span> <a class="code" href="classOgre_1_1PixelBox.html" title="A primitive describing a volume (3D), image (2D) or line (1D) of pixels in memory.">Ogre::PixelBox</a> &amp;src, <span class="keyword">const</span> <a class="code" href="classOgre_1_1PixelBox.html" title="A primitive describing a volume (3D), image (2D) or line (1D) of pixels in memory.">Ogre::PixelBox</a> &amp;dst)
<a name="l00385"></a>00385 {;
<a name="l00386"></a>00386     <span class="keywordflow">switch</span>(FMTCONVERTERID(src.<a class="code" href="classOgre_1_1PixelBox.html#aa4101fdc288dc41dddac88440b4d0818" title="The pixel format.">format</a>, dst.<a class="code" href="classOgre_1_1PixelBox.html#aa4101fdc288dc41dddac88440b4d0818" title="The pixel format.">format</a>))
<a name="l00387"></a>00387     {
<a name="l00388"></a>00388         <span class="comment">// Register converters here</span>
<a name="l00389"></a>00389         CASECONVERTER(A8R8G8B8toA8B8G8R8);
<a name="l00390"></a>00390         CASECONVERTER(A8R8G8B8toB8G8R8A8);
<a name="l00391"></a>00391         CASECONVERTER(A8R8G8B8toR8G8B8A8);
<a name="l00392"></a>00392         CASECONVERTER(A8B8G8R8toA8R8G8B8);
<a name="l00393"></a>00393         CASECONVERTER(A8B8G8R8toB8G8R8A8);
<a name="l00394"></a>00394         CASECONVERTER(A8B8G8R8toR8G8B8A8);
<a name="l00395"></a>00395         CASECONVERTER(B8G8R8A8toA8R8G8B8);
<a name="l00396"></a>00396         CASECONVERTER(B8G8R8A8toA8B8G8R8);
<a name="l00397"></a>00397         CASECONVERTER(B8G8R8A8toR8G8B8A8);
<a name="l00398"></a>00398         CASECONVERTER(R8G8B8A8toA8R8G8B8);
<a name="l00399"></a>00399         CASECONVERTER(R8G8B8A8toA8B8G8R8);
<a name="l00400"></a>00400         CASECONVERTER(R8G8B8A8toB8G8R8A8);
<a name="l00401"></a>00401         CASECONVERTER(A8B8G8R8toL8);
<a name="l00402"></a>00402         CASECONVERTER(L8toA8B8G8R8);
<a name="l00403"></a>00403         CASECONVERTER(A8R8G8B8toL8);
<a name="l00404"></a>00404         CASECONVERTER(L8toA8R8G8B8);
<a name="l00405"></a>00405         CASECONVERTER(B8G8R8A8toL8);
<a name="l00406"></a>00406         CASECONVERTER(L8toB8G8R8A8);
<a name="l00407"></a>00407         CASECONVERTER(L8toL16);
<a name="l00408"></a>00408         CASECONVERTER(L16toL8);
<a name="l00409"></a>00409         CASECONVERTER(B8G8R8toR8G8B8);
<a name="l00410"></a>00410         CASECONVERTER(R8G8B8toB8G8R8);
<a name="l00411"></a>00411         CASECONVERTER(R8G8B8toA8R8G8B8);
<a name="l00412"></a>00412         CASECONVERTER(B8G8R8toA8R8G8B8);
<a name="l00413"></a>00413         CASECONVERTER(R8G8B8toA8B8G8R8);
<a name="l00414"></a>00414         CASECONVERTER(B8G8R8toA8B8G8R8);
<a name="l00415"></a>00415         CASECONVERTER(R8G8B8toB8G8R8A8);
<a name="l00416"></a>00416         CASECONVERTER(B8G8R8toB8G8R8A8);
<a name="l00417"></a>00417         CASECONVERTER(A8R8G8B8toR8G8B8);
<a name="l00418"></a>00418         CASECONVERTER(A8R8G8B8toB8G8R8);
<a name="l00419"></a>00419         CASECONVERTER(X8R8G8B8toA8R8G8B8);
<a name="l00420"></a>00420         CASECONVERTER(X8R8G8B8toA8B8G8R8);
<a name="l00421"></a>00421         CASECONVERTER(X8R8G8B8toB8G8R8A8);
<a name="l00422"></a>00422         CASECONVERTER(X8R8G8B8toR8G8B8A8);
<a name="l00423"></a>00423         CASECONVERTER(X8B8G8R8toA8R8G8B8);
<a name="l00424"></a>00424         CASECONVERTER(X8B8G8R8toA8B8G8R8);
<a name="l00425"></a>00425         CASECONVERTER(X8B8G8R8toB8G8R8A8);
<a name="l00426"></a>00426         CASECONVERTER(X8B8G8R8toR8G8B8A8);
<a name="l00427"></a>00427 
<a name="l00428"></a>00428         <span class="keywordflow">default</span>:
<a name="l00429"></a>00429             <span class="keywordflow">return</span> 0;
<a name="l00430"></a>00430     }
<a name="l00431"></a>00431 }
<a name="l00432"></a>00432 <span class="preprocessor">#undef CASECONVERTER</span>
<a name="l00433"></a>00433 <span class="preprocessor"></span>
<a name="l00436"></a>00436 <span class="preprocessor">#endif // VC6 protection</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:51
</p>
</body>
</html>
